/*
    Sweeper ... 
	This file is a part of sweeper, a program for identifying
	and estimating regression models, selecting from many possible 
	predictors without overfitting.

    Copyright (C) 1999,2002  Robert A. Stine

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License in the file COPYING for more details.
*/
/*
  26 Feb 02 ... Use Bennett's method to compute a conservative p-value.
*/

#ifndef _BENNETT_H_
#define _BENNETT_H_

double
bennett_p_value (double t, double m);  // m is a/b, t is beta^/b

double
bennett_p_value (double bHat, double a, double b);

double
bennett_lower_bound (double beta, double a, double b, double pValue);

#endif
