/*
    Sweeper ... 
	This file is a part of sweeper, a program for identifying
	and estimating regression models, selecting from many possible 
	predictors without overfitting.

    Copyright (C) 1999,2002  Robert A. Stine

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License in the file COPYING for more details.
*/
// $Id: random.h,v 1.1 2000/07/12 14:43:24 bob Exp $

#ifndef _RANDOM_
#define _RANDOM_

typedef struct rs
{
  int   type;
  long  *ptr;
  int	len;
}  aRandomState;

typedef aRandomState *RandomState;


void InitializeRandomGenerator (int gen, unsigned long seed);
/*
  Pick a random generator.
  Initializes its value from system clock if seed is zero.
*/

int HaveValidRandomState(void);


RandomState CurrentRandomState (void);

void PrintRandomState(RandomState state);


void SetRandomState (RandomState state);

void FreeRandomState (RandomState state);
/*
  Read, set and free a random state.
*/

double UniformRand(void);

double NormalRand(void);

double CauchyRand(void);

double GammaRand (double a);

double ChiSqRand (double df);

double tRand (double df);

double BetaRand (double a, double b);

double FRand (double ndf, double ddf);

#endif











