/*
    Sweeper ... 
	This file is a part of sweeper, a program for identifying
	and estimating regression models, selecting from many possible 
	predictors without overfitting.

    Copyright (C) 1999,2002  Robert A. Stine

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License in the file COPYING for more details.
*/
// $Id: sorter.h,v 1.2 2000/10/27 21:31:20 bob Exp $

#include <iostream>
#include <map>

class Key: public std::pair<double,double>
{
public:
  Key(double rss, double fstat):
    std::pair<double,double>(rss,fstat)
    {
    }
};

class Key_sorter
{
public:

  bool
  operator()(Key lhs, Key rhs);  // act like: (lhs < rhs)

  static double s_threshold;
};


typedef std::multimap<Key,long,Key_sorter> Sort_tree;


std::ostream&
operator<<(std::ostream& ostrm, std::pair<Key,int> obj);




