/*
    Sweeper ... 
	This file is a part of sweeper, a program for identifying
	and estimating regression models, selecting from many possible 
	predictors without overfitting.

    Copyright (C) 1999,2002  Robert A. Stine

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License in the file COPYING for more details.
*/
#ifndef TAGGEDLIST
#define TAGGEDLIST

#define Tag long
#define TaggedList TaggedListNode


typedef struct taggedListNode
{	Tag tag;
	void *object;
	struct taggedListNode *next;
} TaggedListNode;


TaggedList * NewTaggedList();


TaggedListNode	*TaggedListMember(TaggedList *list, Tag tag);


TaggedListNode	*InsertIntoTaggedList (TaggedList *list, Tag tag, void *object);

void 			*ExtractFromTaggedList(TaggedList *list, Tag tag);

void *ObjectInTaggedList(TaggedList *list, Tag tag);

void PrintTags (TaggedList *list);				

void PrintTaggedList(TaggedList *list, void (*printObj)(void *));

#endif

/*
	24 Oct 98 ... Created.
*/
